Program clip_pas; { Sprite clipping example: CLIP_PAS.PAS }

Uses TJVga,Dos,TJKeyb,Crt;

Const SpriteWidth=32; {The dimensions of your sprite }
      SpriteHeight=32;

Type Sprite_type=Array[0..SpriteWidth*SpriteHeight]of byte;

Var i,j:integer;
    sprite:sprite_type; { The sprite data }
    sx,sy:integer; { Position of sprite }
    LeftClip,RightClip,TopClip,BottomClip:integer; { The clipping borders }

Procedure InitGraphics;
var i,j:integer;
begin
SetMCGA;                              { Set Mode 13h }
SetupVirtual;                         { Allocate memory for virtual buffer }
cls(vaddr,0);                         { Clear it! }
LeftClip:=0;                          { Assign startup values for }
RightClip:=319;                       { the clipping borders! }
TopClip:=0;
BottomClip:=199;
LoadPCX('sprite.pcx',0,0,Vaddr);      { Load the PCX-file }
for i := 1 to SpriteWidth do
 for j := 1 to SpriteHeight do
  sprite[(j*SpriteHeight)+i]:=getpixel(i,j,vaddr);
cls(vaddr,0);
end;

Procedure ShutGraphics;
begin
ShutDown;    { Deallocate memory for virtual buffer }
SetText;     { Set Mode 3h (Text mode)}
end;

Procedure ClipAndDrawSprite(x,y:integer; where:word);
Var i,j:integer;
    tw,th:integer; { new sprite width, height }
    gx,gy:integer; { Where to start drawing the sprite }
begin
if (x<RightClip) and (x>(LeftClip-SpriteWidth))
and (y<BottomClip) and (y>(TopClip-SpriteHeight)) then begin
tw:=SpriteWidth; th:=SpriteHeight;
gx:=1; gy:=1;

if (x < LeftClip) then              { Clip left side of sprite }
        inc(gx,LeftClip-x);

if ((x + SpriteWidth)>RightClip) then { Clip right side of sprite }
   dec(tw,(X + SpriteWidth) - RightClip);

if (y <  TopClip) then              { Clip Top of sprite }
        inc(gy,TopClip-y);

if ((y + SpriteHeight)>BottomClip) then  { Clip Bottom of sprite }
    dec(th,(Y + SpriteHeight) - BottomClip);

for i := gx to tw do
 for j := gy to th-1 do
   putpixel(i+x,j+y,sprite[(j*SpriteHeight)+i],where);    { Draw it! }
  end;
end;

Procedure DrawClippingBorders(c:byte); { Guess? }
begin
Line(LeftClip,TopClip,RightClip,TopClip,14,vaddr);
Line(LeftClip,TopClip,LeftCLip,BottomClip,15,vaddr);
Line(RightClip,TopClip,RightClip,BottomClip,15,vaddr);
Line(LeftCLip,BottomClip,RightClip,BottomClip,14,vaddr);
end;

Procedure Center(s:string; row:integer; fc,bc:byte); { Write a centerd string }
var i,j:integer;
begin
textcolor(fc);
textbackground(bc);
i:=40-(length(s) div 2);
gotoxy(i,row);
write(s);
end;


begin
ClrScr;
InitGraphics;
InitNewKeyInt; { Initialize new keyboard interrupt }
sx:=160;
sy:=100;
LeftClip:=0;                          { Assign startup values for }
RightClip:=319;                       { the clipping borders! }
TopClip:=0;
BottomClip:=199;

repeat
if keydown[leftscan] then dec(sx);
if keydown[rightscan] then inc(sx);
if keydown[upscan] then dec(sy);
if keydown[downscan] then inc(sy);
if keydown[scanof('i')] then dec(BottomClip);
if keydown[scanof('j')] then dec(RightClip);
if keydown[scanof('k')] then inc(TopClip);
if keydown[scanof('l')] then inc(LeftClip);
ClipAndDrawSprite(sx,sy,vaddr);
DrawClippingBorders(random(15)+16); { Shows the clipping borders }
flip(vaddr,vga); { Flip virtual buffer to $A000, show it! }
cls(vaddr,0); { clear the virtual buffer }
waitretrace; { For smoother animation }
until keydown[escscan];
SetOldKeyInt; { Restore old keyboard interrupt }
ShutGraphics;
Writeln('Chemix -98 : GeneralZoftware@pemail.com');
end.
